Module lib_prod Import lib_eq_basics;

(* Contents
   --------
   o The product datatype.
*)
 
Inductive [prod:Type] ElimOver Type
Parameters [A,B:Type]
Constructors [pair1:{a:A}{b:B}prod];

Discharge A;

Pair [A,B|Type][a:A][b:B] == pair1 A B a b;

[s,t|Type];

(*

$[prod : Type->Type->Type];

$[Pair:s->t->(prod s t)];

$[prod_elim : {T:(prod s t)->Type}
               ({a:s}{b:t}T (Pair a b))->
                 {p:prod s t}T p];

[[T:(prod s t)->Type][e:{a:s}{b:t}T (Pair a b)][a:s][b:t]
  prod_elim T e (Pair a b) ==> e a b];
*)
[    prod_rec = [u|Type]prod_elim s t [_:prod s t]u
            : {u|Type}(s->t->u)->(prod s t)->u
]
[    prod_ind = [P:(prod s t)->Prop]prod_elim s t P
            : {P:(prod s t)->Prop}
              ({a:s}{b:t}P (Pair a b))->
                {p:prod s t}P p
]
[    Fst = prod_rec [a:s][_:t]a

            : (prod s t)->s
]
[    Snd = prod_rec [_:s][b:t]b
            : (prod s t)->t
];

Goal prod_eta : {p:prod s t}Eq p (Pair (Fst p) (Snd p));
Refine prod_ind[p:prod s t]Eq p (Pair (Fst p) (Snd p));
intros;
Refine Eq_refl;
Save prod_eta;

Goal prod_ext : {p,q:prod s t}(Eq (Fst p) (Fst q))->(Eq (Snd p) (Snd q))->Eq p q;
intros;
Qrepl prod_eta p;
Qrepl H;
Qrepl H1;
Refine Eq_sym (prod_eta ?);
Save prod_ext;

Discharge s;

